include("KImage.js");

const params_per_group = 12;
const param_noteid = 0;
const param_fontface = 1;
const param_fontsize= 2;
const param_fontcolor = 3;
const param_fontstyle = 4;
const param_hueadjust = 5;
const param_hueadjust_enable = 6;
const param_x = 7;
const param_y = 8;
const param_w = 9;
const param_h = 10;
const param_text = 11;

function init() {
	
	wndArray = new Array();
	frmNote = new Array();
	picMain = new Array();
	picResize = new Array();
	txtArea = new Array();
	
	openedNotes = 0;
	
	frmNoteSettings = Array();
	
	frmNoteSettings[0] = new FormField();
	frmNoteSettings[0].name = "font_face";
	frmNoteSettings[0].type = "font";
	frmNoteSettings[0].title = "Font face";
	frmNoteSettings[0].defaultValue = "Arial";
	frmNoteSettings[0].description = "WARNING: Due to a limitation of the widget engine, it is recommended to select a \'basic\' font name. Example : \'Arial\' will work fine but \'Arial Bold\' will not. If you want such a result, select \'Arial'\ in the popup list and then enable the \'Bold\' attribute with the checkbox belox.";
	
	frmNoteSettings[1] = new FormField();
	frmNoteSettings[1].name = "font_bold";
	frmNoteSettings[1].type = "checkbox";
	frmNoteSettings[1].title = "Bold";
	frmNoteSettings[1].defaultValue = 0;
	
	frmNoteSettings[2] = new FormField();
	frmNoteSettings[2].name = "font_italic";
	frmNoteSettings[2].type = "checkbox";
	frmNoteSettings[2].title = "Italic";
	frmNoteSettings[2].defaultValue = 0;
	
	frmNoteSettings[3] = new FormField();
	frmNoteSettings[3].name = "font_size";
	frmNoteSettings[3].type = "popup";
	frmNoteSettings[3].title = "Font size";
	frmNoteSettings[3].defaultValue = 12;
		
	pupFontSize = new Array();
	pupFontSize[0] = "6";
	pupFontSize[1] = "8";
	pupFontSize[2] = "9";
	pupFontSize[3] = "10";
	pupFontSize[4] = "11";
	pupFontSize[5] = "12";
	pupFontSize[6] = "14";
	pupFontSize[7] = "18";
	pupFontSize[8] = "24";
	pupFontSize[9] = "30";
	pupFontSize[10] = "36";
	pupFontSize[11] = "48";
	pupFontSize[12] = "60";
	pupFontSize[13] = "72";
	
	frmNoteSettings[3].option = pupFontSize;
	
	// frmNoteSettings[1].description = "Enter the font size you want.";
	
	frmNoteSettings[4] = new FormField();
	frmNoteSettings[4].name = "font_color";
	frmNoteSettings[4].type = "color";
	frmNoteSettings[4].title = "Font color";
	frmNoteSettings[4].defaultValue = "#000000";
	// frmNoteSettings[2].description = "Pick a color for the font you selected."
	
	frmNoteSettings[5] = new FormField();
	frmNoteSettings[5].name = "postit_color";
	frmNoteSettings[5].type = "slider";
	frmNoteSettings[5].title = "PostIt custom color";
	frmNoteSettings[5].minLength = -180;
	frmNoteSettings[5].maxLength = 180;
	frmNoteSettings[5].defaultValue = 0;
	
	// frmNoteSettings[3].description = "Use this setting to apply a custom color to the background.";
	
	//frmNoteSettings[6] = new FormField();
	//frmNoteSettings[6].name = "postit_color_switch";
	//frmNoteSettings[6].type = "checkbox";
	//frmNoteSettings[6].title = "Enable custom PostIt color";
	//frmNoteSettings[6].defaultValue = 0;
	//frmNoteSettings[6].description = "Use this checkbox to turn on/off usage of a custom color.";
	
	if (preferences.filePath.value == "") {
     preferences.filePath.value = system.widgetDataFolder + "/PostIt Widget Datafile.txt";
		 filesystem.copy("PostIt FirstLaunch Datafile.txt", preferences.filePath.value);
	}
	
}

function makeUpContextMenu(handle) {

	ctxMenu = new Array();
	ctxMenuIdx = 0;
	
	ctxMenu[ctxMenuIdx] = new MenuItem;
	ctxMenu[ctxMenuIdx].title = "Per note settings...";
	ctxMenu[ctxMenuIdx].onSelect = "openPerNoteSettings(" + handle + ");";
	ctxMenuIdx++;
	
	ctxMenu[ctxMenuIdx] = new MenuItem;
	ctxMenu[ctxMenuIdx].title = "Choose custom note color...";
	ctxMenu[ctxMenuIdx].onSelect = "openColorSelector(" + handle + ");";
	ctxMenuIdx++;
	
	ctxMenu[ctxMenuIdx] = new MenuItem;
	ctxMenu[ctxMenuIdx].title = "New note";
	if (preferences.randomColor.value == "1") {
		rndcolor = (Math.floor(Math.random()*361)-180);
		print(rndcolor);
		ctxMenu[ctxMenuIdx].onSelect = "newPostIt(system.event.screenX-30, system.event.screenY-30, 300, 300, 'Arial', 14, '#000000', '', " + rndcolor + ", 1, '', true);";
	} else {
		ctxMenu[ctxMenuIdx].onSelect = "newPostIt(system.event.screenX-30, system.event.screenY-30, 300, 300, 'Arial', 14, '#000000', '', 0, 0, '', true);";
	}
	ctxMenuIdx++;
	
	ctxMenu[ctxMenuIdx] = new MenuItem;
	ctxMenu[ctxMenuIdx].title = "Delete this note";
	ctxMenu[ctxMenuIdx].onSelect = "deletePostIt(" + handle + ");";
	if (openedNotes > 1) {
		ctxMenu[ctxMenuIdx].enabled = true;
	} else {
		ctxMenu[ctxMenuIdx].enabled = false;
	}
	ctxMenuIdx++;
	
	//ctxMenu[ctxMenuIdx] = new MenuItem;
	//ctxMenu[ctxMenuIdx].title = "Export this PostIt as ASCII text file...";
	//ctxMenu[ctxMenuIdx].onSelect = "print('TODO_ExportASCII');";
	//ctxMenuIdx++;
	
	//ctxMenu[ctxMenuIdx] = new MenuItem;
	//ctxMenu[ctxMenuIdx].title = "Import ASCII text file into this PostIt...";
	//ctxMenu[ctxMenuIdx].onSelect = "print('TODO_ImportASCII');";
	//ctxMenuIdx++;

	wndArray[handle].contextMenuItems = ctxMenu;
	
}

function openPerNoteSettings(handle) {
	
	frmNoteSettings[0].defaultValue = txtArea[handle].font;
	if (txtArea[handle].style.indexOf("bold") != -1) {
		frmNoteSettings[1].defaultValue = 1;
	} else {
		frmNoteSettings[1].defaultValue = 0;
	}
	if (txtArea[handle].style.indexOf("italic") != -1) {
		frmNoteSettings[2].defaultValue = 1;
	} else {
		frmNoteSettings[2].defaultValue = 0;
	}
	frmNoteSettings[3].defaultValue = txtArea[handle].size;
	frmNoteSettings[4].defaultValue = txtArea[handle].color;
	frmNoteSettings[5].defaultValue = picMain[handle].hslAdjustmentHueValue;
	// frmNoteSettings[6].defaultValue = picMain[handle].hslAdjustmentEnabled;
		
	formResults = form(frmNoteSettings, "Per PostIt settings (handle : " + handle + ")", "OK", "Cancel");
	
	print("FrmNoteSettings = " + formResults);
	
	if (formResults != null) {
		styl = "";
		if (formResults[1] == 1)
			styl = "bold";
		if (formResults[2] == 1) {
			if (styl == "") {
				styl = "italic";
			} else {
				styl = styl + ";italic";
			}
		}
		print(styl);
		updatePostIt(handle, formResults[0], formResults[3], formResults[4], styl, formResults[5], formResults[6]);
		saveNoteFile();
	}
}

function openColorSelector(handle) {

	wndColorSelector = new Window();
	wndColorSelector.hOffset = system.event.screenX;
	wndColorSelector.vOffset = system.event.screenY;
	wndColorSelector.width = 231;
	wndColorSelector.height = 74;
	
	picForm = new Image();
	picForm.window = wndColorSelector;
	picForm.src = "Resources/ColorSelectorForm.png";
	picForm.hOffset = 0;
	picForm.vOffset = 0;
	picForm.zOrder = 0;
	
	picSliderBox = new Image();
	picSliderBox.window = wndColorSelector;
	picSliderBox.src = "Resources/ColorSelectorSliderBox.png";
	picSliderBox.hOffset = 11;
	picSliderBox.vOffset = 16;
	picSliderBox.zOrder = 1;
	
	picSlider = new Image();
	picSlider.window = wndColorSelector;
	picSlider.src = "Resources/ColorSelectorSlider.png";
	picSlider.hOffset = 100;
	dumVal = parseInt(picMain[handle].hslAdjustmentHueValue);
	dumVal = (((dumVal + 180) * 206) / 360) - 4;
	picSlider.hOffset = dumVal.toFixed(0);
	picSlider.vOffset = 13;
	picSlider.zOrder = 2;
	picSlider.onMouseMove = "colorSliderMove(" + handle + ");";
	
	picOK = new Image();
	picOK.window = wndColorSelector;
	picOK.src = "Resources/ColorSelectorOK.png";
	picOK.hOffset = 80;
	picOK.vOffset = 45;
	picOK.zOrder = 3;
	picOK.tracking = "rectangle";
	picOK.onMouseEnter = "picOK.hslAdjustment = \"0, 0, +100\";";
	picOK.onMouseExit = "picOK.hslAdjustment = \"0, 0, 0\";";
	picOK.onMouseUp = "wndColorSelector.visible = false;";
	
}

function colorSliderMove(handle) {
  if ((system.event.screenX >= wndColorSelector.hOffset + picSliderBox.hOffset) && (system.event.screenX <= wndColorSelector.hOffset + picSliderBox.hOffset + picSliderBox.width - 6))
  {
    picSlider.hOffset = picSlider.hOffset + system.event.x - 4;
		sliderValue = (((picSlider.hOffset + 4) * 360) / 210) - 180;
  }
	picMain[handle].hslAdjustmentHueValue = sliderValue.toFixed(0);
	picMain[handle].hslAdjustment = sliderValue*picMain[handle].hslAdjustmentEnabled + ", 0, 0";
}

function newPostIt(x, y, w, h, fntFace, fntSize, fntColor, fntStyle, picHsl, picHslEnable, text, save) {

	i = wndArray.length++
	wndArray[i] = new Window();
	wndArray[i].hOffset = x;
	wndArray[i].vOffset = y;
	wndArray[i].width = w;
	wndArray[i].height = h;
	wndArray[i].onContextMenu = "makeUpContextMenu(" + i + ");";

	frmNote[i] = new Frame();
  frmNote[i].window = wndArray[i];
  frmNote[i].hOffset = 0;
  frmNote[i].vOffset = 0;
  frmNote[i].width = wndArray[i].width;
  frmNote[i].height = wndArray[i].height;
  frmNote[i].zOrder = 0;
  frmNote[i].opacity = 0;

  picMain[i] = new KImage();
  picMain[i].window = wndArray[i];
  picMain[i].src = "Resources/PostIt*.png";
  picMain[i].hOffset = 0;
  picMain[i].vOffset = 0;
  picMain[i].width = wndArray[i].width;
  picMain[i].height = wndArray[i].height;
	picMain[i].hslAdjustmentEnabled = 1; //picHslEnable
	picMain[i].hslAdjustmentHueValue = picHsl;
	picMain[i].hslAdjustment = picHsl + ", 0, 0"; //picHsl*picHslEnable + ", 0, 0"
  picMain[i].zOrder = 1;
	
	txtArea[i] = new TextArea();
  txtArea[i].window = wndArray[i];
  txtArea[i].editable = true;
  txtArea[i].scrollbar = false;
  txtArea[i].spellcheck = false;
  txtArea[i].hOffset = 27;
  txtArea[i].vOffset = 17;
  txtArea[i].width = wndArray[i].width - 46;
  txtArea[i].height = wndArray[i].height - 40;
  txtArea[i].color = fntColor;
  txtArea[i].alignement = "left";
  txtArea[i].font = fntFace;
	txtArea[i].size = fntSize;
	txtArea[i].style = fntStyle;
  txtArea[i].zOrder = 2;
  txtArea[i].onLoseFocus = "saveNoteFile();";
	txtArea[i].data = text;
	
	picResize[i] = new Image();
  picResize[i].window = wndArray[i];
  picResize[i].src = "Resources/ResizeAnchor.png";
  picResize[i].hOffset = wndArray[i].width - 31;
  picResize[i].vOffset = wndArray[i].height - 34;
  picResize[i].opacity = 1;
  picResize[i].tracking = "rectangle";
  picResize[i].onMouseEnter = "picResize[" + i + "].opacity = 150;";
  picResize[i].onMouseExit = "picResize[" + i + "].opacity = 1;";
  picResize[i].onMouseMove = "postItResize(" + i + ");";
  picResize[i].zOrder = 3;
	
	openedNotes++;
	
	if (save == true)
		saveNoteFile();
	
}

function deletePostIt(handle) {

	if (openedNotes > 1) {
		wndArray[handle].visible = false;
		openedNotes--;
	} else {
		alert("There should be at least one opened note when the widget is running, in order to preserve all its functionalities.", "OK");
	}

}

function updatePostIt(handle, fntFace, fntSize, fntColor, fntStyle, picHsl, picHslEnable) {

	picMain[handle].hslAdjustmentEnabled = 1; //picHslEnable
	picMain[handle].hslAdjustmentHueValue = picHsl;
	picMain[handle].hslAdjustment = picHsl + ", 0, 0"; //picHsl*picHslEnable + ", 0, 0"
	
	//if (picHslEnable == 1) {
	//	picMain[handle].hslAdjustment = picHsl + ", 0, 0";
	//} else {
	//	picMain[handle].hslAdjustment = "";
	//}
	
	txtArea[handle].color = fntColor;
  txtArea[handle].font = fntFace;
	txtArea[handle].size = fntSize;
	txtArea[handle].style = fntStyle;
  
}

function onLoad() {

  init();

	notefile = filesystem.readFile(preferences.filePath.value, false);
	if (notefile != null) {
		parseFile(notefile);
		openInstances();
	} else {
		alert("The PostIt Widget Datafile could not be found. An empty one will be opened. Please set the desired location for it in the widget preferences.", "OK");
		newPostIt(100, 100, 300, 300, "Arial", 14, "#000000", "none", 0, 0, "", false);
	}
	
}

function saveNoteFile() {

	var savestr = "";
	var firstGroup = true;
	for (i = 0; i < wndArray.length; i++) {
		if (wndArray[i].visible == true) {
			if (firstGroup == false)
				savestr = savestr + ",";
			savestr = savestr + "POSTIT_WIDGET=" + i + ",";
			savestr = savestr + "FONT_FACE=" + txtArea[i].font + ",";
			savestr = savestr + "FONT_SIZE=" + txtArea[i].size + ",";
			savestr = savestr + "FONT_COLOR=" + txtArea[i].color + ",";
			savestr = savestr + "FONT_STYLE=" + txtArea[i].style + ",";
			savestr = savestr + "POSTIT_HUEADJUST=" + picMain[i].hslAdjustmentHueValue + ",";
			savestr = savestr + "POSTIT_HUEADJUST_ENABLED=" + picMain[i].hslAdjustmentEnabled + ",";
			savestr = savestr + "X=" + wndArray[i].hOffset + ",";
			savestr = savestr + "Y=" + wndArray[i].vOffset + ",";
			savestr = savestr + "W=" + wndArray[i].width + ",";
			savestr = savestr + "H=" + wndArray[i].height + ",";
			savestr = savestr + "MESSAGE=" + txtArea[i].data.replace(/\=/g, "&equal;");
			firstGroup = false;
		}
	}
	if (savestr != "")
		filesystem.writeFile(preferences.filePath.value, savestr);
}

function parseFile(file) {

	cmdstring = file;
	
	parameters = file.split(/,(?=\w+=)/);

	keys = new Array();
	values = new Array();
	
	for (i = 0; i < parameters.length; i++) {
		parameter = parameters[i];
		pair = parameter.split("=");
		
		keys[i] = pair[0];
		values[i] = pair[1];
		
		print(parameters[i] + ' > ' + keys[i] + ' = ' + values[i]);
	}
	if (parameters.length % params_per_group == 0) {
		print("Ok, number of parameters is correct : " + parameters.length % params_per_group);
		groups = parameters.length / params_per_group;
		print("We have " + groups + " group(s) here.");
	} else {
		var res = alert("An error occured while reading the datafile. If you are updating from version 1.0, this is fully normal. Please click the Update button to create a valid datafile. Click the Abort button to shutdown the widget.", "Update", "Abort");
		switch (res) {
		case 1:
			filesystem.copy(preferences.filePath.value, preferences.filePath.value + ".backup");
			filesystem.copy("PostIt FirstLaunch Datafile.txt", preferences.filePath.value);
			alert("Your previous note file was given the \'.backup\' extention. You are now using a valid file. The widget will now restart.", "OK");
			reloadWidget();
			break
		case 2:
			closeWidget();
			break
		default:
		}
	}

	}

function openInstances() {

	if (groups > 0) {
		for (i = 0; i < groups; i++) {
			newPostIt(values[(i*params_per_group)+param_x], values[(i*params_per_group)+param_y], values[(i*params_per_group)+param_w], values[(i*params_per_group)+param_h], values[(i*params_per_group)+param_fontface], values[(i*params_per_group)+param_fontsize], values[(i*params_per_group)+param_fontcolor], values[(i*params_per_group)+param_fontstyle], values[(i*params_per_group)+param_hueadjust], values[(i*params_per_group)+param_hueadjust_enable], values[(i*params_per_group)+param_text].replace(/&equal;/g, "="), false);
		}
	}

}

function postItResize(handle) {
  if (system.event.hOffset >= 140)
  {
    picResize[handle].hOffset = picResize[handle].hOffset + system.event.x - 8;
    picMain[handle].width = picMain[handle].width + system.event.x - 8;
    txtArea[handle].width = txtArea[handle].width + system.event.x - 8;
    frmNote[handle].width = frmNote[handle].width + system.event.x - 8;
    wndArray[handle].width = wndArray[handle].width + system.event.x - 8;
  }
  if (system.event.vOffset >= 140)
  {
    picResize[handle].vOffset = picResize[handle].vOffset + system.event.y - 8;
    picMain[handle].height = picMain[handle].height + system.event.y - 8;
    txtArea[handle].height = txtArea[handle].height + system.event.y - 8;
    frmNote[handle].height = frmNote[handle].height + system.event.y - 8;
    wndArray[handle].height = wndArray[handle].height + system.event.y - 8;
  }
}

function exit() {

	// saveNoteFile();
	// A nasty bug was happening here. Sometimes, X and Y parameters in the notefile were bizarre (11354498 -168494497).

}

onLoad();